;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;				Сортировка с анимацией	v2.08
;;		Управление
;; Пробел: старт/стоп
;; Ентер: сброс
;; + / -: быстрей/медленей
;; Q / A: выбор сортировки, предыдущая/следующая
;; (с) Intro  wasm.in			Создан: 24‎.12.‎2022 19:16	Изменён: 16‎.01.‎2023 12:00
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
_USE_FUNC_ExitProcess_		EQU <>	;использовать ExitProcess для завершения

.686
.xmm
.model flat,stdcall
option casemap:none
option SWITCHSTYLE:ASMSTYLE
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib
include msvcrt.inc
include macros.asm

;флаги главного окна! 
WS_MAIN_FORM		= WS_VISIBLE or WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX
MS_BASE_LABEL		= WS_CHILD or WS_VISIBLE or SS_BITMAP
MAX_SLEEP			= 0
MIN_SLEEP			= 500
STEP_SLEEP			= 5

ArraySize			= 150
ColumnWidth			= 9		;ширина, 1 пиксель между столбиками
ColumnHeight		= 512
FormWidth			= ArraySize*(ColumnWidth+1)+9
FormHeight			= 650
FormHeightMin		= 570
FormX				= 50
FormY				= 20

;ID'шники контролов
MAIN_FORM_ID		= 0
TIMER_ID			= 1
ICON_ID				= 2


ListFuncs MACRO name_list:req, list:VARARG
LOCAL name_func, num, strNameFunc, strTmp
	strNameFunc	EQU <>
	strTmp		EQU <>
	;;
	sListFuncs struct ;(sizeof=8, align=4)
		pProc		dword ?		;0 			//указатель на функцию
		sNameProc	dword ?		;4 *char	//имя функций
	sListFuncs ends
	;;генерируем список строк с названиями
	num	= 0
	FOR name_func,<list>
		strNameFunc CATSTR <aNameFunc??>,<name_list>,<??_>,%num, < db ">,<name_func>,<",0>
		align 4
		strNameFunc
;;		% echo @CatStr(%strNameFunc)
		num = num + 1
	ENDM
	;;генерируем список структуры
	align 4
	num	= 0
	FOR name_func,<list>
		strNameFunc	CATSTR <aNameFunc??>,<name_list>,<??_>,%num
		IF num EQ 0
			strTmp	CATSTR <name_list>,< sListFuncs {offset >,<name_func>,<, offset >, <strNameFunc>,<}>
		ELSE
			strTmp	CATSTR <sListFuncs {offset >,<name_func>,<, offset >, <strNameFunc>,<}>
		ENDIF
		strTmp
		;;генерируем переменную с номером
		strTmp	CATSTR <number_>,<name_func>,< = >,%num
		strTmp
		num = num + 1
	ENDM
	;;генерируем макро переменную с размером списка
	strTmp	CATSTR <name_list>,<_Size = >,%num
	strTmp
ENDM

.const
ClassName			db "DemoSort",0
align 4
aStatic				db "static", 0
align 4
aDisplay			db "DISPLAY", 0
;список функций сортировки
ListFuncs	lstFuncSort,	BubbleSort,		BrickSort,		QuickSort,	ShakerSort,	HeapSort, \
							ShellSort,		SelectionSort,	GnomeSort,	CombSort,	InsertionSort, \
							MergeSort,		PancakeSort,	RadixSort,	StoogeSort,	CycleSort, \
							CocktailSort,	CountingSort,	BeadSort,	TreeSort,	SlowSort, \
							BitonicSort,	BasketSortNB

.data?
RealArraySize	= 1
WHILE RealArraySize LT ArraySize	;;<
	RealArraySize	= RealArraySize*2
ENDM
Array				dword	RealArraySize dup(?)
bComparison			byte	RealArraySize dup(?)
align 4
hInstance			dword ?
countSwap			dword ?
countComp			dword ?
hdcMainForm			HDC ?
ThreadID			dword ?
BrushColumn			HDC ColumnHeight dup(?)
g_iDelay			sdword ?	;int
g_iDelayPause		sdword ?	;int
g_iNumFunc			sdword ?	;=0
g_iColumnWidth		sdword ?
g_bActiveProcces	byte ?		;Процесс в работе
g_bPause			byte ?		;Пауза
g_bBreak			byte ?		;Прервать
g_bReadyStart		byte ?		;Готово с старту

.code
WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
local frmX:sdword, frmY:sdword, frmWidth:sdword, frmHeight:sdword
local wc:WNDCLASSEX, msg:MSG
	mov		ebx, CreateDC(&aDisplay, NULL, NULL, NULL);display - ebx
	mov		esi, GetDeviceCaps(ebx, HORZRES)	;=iHorzPixel
	mov		edi, GetDeviceCaps(ebx, VERTRES)	;=iVertPixel
	DeleteDC(ebx)
	mov		eax, esi
	sub		eax, FormWidth
	.if (sdword ptr eax<0)
		mov		eax, esi
		mov		ecx, ArraySize
		xor		edx, edx
		div		ecx
		lea		edx, [eax-1]
		mov		g_iColumnWidth, edx
		imul	eax, ecx
		add		eax, 9
		mov		frmWidth, eax
		neg		eax
		add		eax, esi
	.else
		mov		g_iColumnWidth, ColumnWidth
		mov		frmWidth, FormWidth
	.endif
	shr		eax, 1;/=2
	mov		frmX, eax
	mov		frmHeight, FormHeight
	lea		eax, [edi-FormHeight]
	.if (sdword ptr eax<50)
		mov		frmHeight, FormHeightMin
		xor		eax, eax
	.elseif (sdword ptr eax<120)
		xor		eax, eax
	.endif
	shr		eax, 2;/=4
	add		eax, 5
	mov		frmY, eax
;-------------------------------------
;edi -	hWnd:HWND
	lea		esi, wc
	ASSUME	esi:ptr WNDCLASSEX, edi:ptr MSG
	mov		[esi].cbSize, sizeof WNDCLASSEX
	mov		[esi].style, CS_BYTEALIGNCLIENT
	mov		[esi].lpfnWndProc, offset WndProc
	mov		[esi].cbClsExtra, NULL
	mov		[esi].cbWndExtra, NULL
	mov		eax, hInst
	mov		[esi].hInstance, eax
	mov		hInstance, eax
	mov		[esi].hbrBackground, COLOR_WINDOWTEXT
	mov		[esi].lpszClassName, offset ClassName
	mov		[esi].hIcon, LoadIcon(NULL, ICON_ID);IDI_APPLICATION
	mov		[esi].hIconSm, eax
	mov		[esi].hCursor, LoadCursor(NULL, IDC_ARROW)
	RegisterClassEx(esi)
	mov		ebx, CreateWindowEx(0,&ClassName,&ClassName,WS_MAIN_FORM,frmX,frmY,frmWidth,frmHeight,0,MAIN_FORM_ID,hInst,0)
	ShowWindow(ebx, SW_SHOWNORMAL)
	UpdateWindow(ebx)
	lea		edi, msg
	.while (true)
		GetMessage(edi, 0, 0, 0)
		.break .if (!eax)
		TranslateMessage(edi)
		DispatchMessage(edi)
	.endw
	mov		eax, [edi].wParam
	ASSUME	esi:nothing, edi:nothing
	ret
WinMain endp

include FuncSortir.asm

align_proc
ColorGradient proc (dword) len:dword
local res:CRGB
	mov		res.bExtra, 0
	mov		eax, len
	.if (eax<128)
		mov		dl, 255
		add		al, al
		sub		dl, al
	.elseif (eax<224)
		mov		dl, 0
	.elseif (eax<342)
		sub		eax, 224
		mov		dl, al
	.elseif (eax<374)
		mov		dl, 114
	.elseif (eax<470)
		sub		eax, 374
		mov		dl, 114
		add		dl, al
	.else
		mov		dl, 207
		sub		eax, 470
		add		dl, al
	.endif
	mov		res.bRed, dl
;----blue-------------------------------------
	mov		eax, len
	.if (eax<64)
		xor		dl, dl
	.elseif (eax<128)
		sub		al, 64
		add		al, al
		mov		dl, al
	.elseif (eax<160)
		sub		al, 128
		mov		dl, 128
		add		dl, al
	.elseif (eax<192)
		sub		eax, 160
		mov		dl, 159
		add		dl, al
	.elseif (eax<224)
		mov		dl, 190
		sub		eax, 192
		add		dl, al
	.elseif (eax<256)
		sub		eax, 224
		mov		dl, 221
	.elseif (eax<288)
		sub		eax, 256
		mov		dl, 221
		sub		dl, al
	.elseif (eax<310)
		mov		dl, 190
		sub		eax, 288
		sub		dl, al
	.elseif (eax<342)
		mov		dl, 169
		sub		eax, 310
		sub		dl, al
	.elseif (eax<374)
		mov		dl, 138
		sub		eax, 342
		sub		dl, al
	.elseif (eax<406)
		mov		dl, 107
		sub		eax, 374
		sub		dl, al
	.elseif (eax<438)
		mov		dl, 76
		sub		eax, 406
		sub		dl, al
	.elseif (eax<470)
		mov		dl, 45
		sub		eax, 438
		sub		dl, al
	.else
		mov		dl, 14
		sub		dl, al
	.endif
	mov		res.bBlue, dl
;---green---------------------------------
	mov		eax, len
	.if (eax<64)
		mov		dl, 128
		add		al, al
		add		dl, al
	.elseif (eax<96)
		mov		dl, 255
	.elseif (eax<128)
		mov		dl, 255
		sub		al, 96
		add		al, al
		sub		dl, al
	.elseif (eax<310)
		sub		al, 128
		mov		dl, 192
		sub		dl, al
	.else
		mov		dl, 0
	.endif
	mov		res.bGreen, dl
;------------------------------------
	mov		eax, res
	ret
ColorGradient endp

align_proc
Mixing proc uses edi
local time:SYSTEMTIME
	GetLocalTime(&time)
	movzx	eax, time.wSecond
	inc		eax
	shr		eax, 1	;/=2
	imul	ax, time.wMilliseconds
	srand(eax)
	.for (edi=0: edi<ArraySize: edi++)
		rand()		;0..32767
		shr		eax, 6		;/=64
	;	and		eax, 1FFh	;%=512
		mov		Array[edi*4], eax	;0..511
	.endfor
	ret
Mixing endp

sWPARAM union ; (sizeof=4, align=4)
	w				dword ?		;
	struct
		lo			word ?		;
		hi			word ?		;
	ends
	struct
		b0			byte ?		;
		b1			byte ?		;
		b2			byte ?		;
		b3			byte ?		;
	ends
sWPARAM ends

align_proc
WndProc proc uses esi edi ebx hWnd:HWND, uMsg:UINT, wParam:sWPARAM, lParam:sWPARAM
local rect:RECT, buff[80]:byte
	mov		ebx, uMsg
	.if (ebx == WM_TIMER)
		.if (g_bBreak && g_bActiveProcces==false)
			Mixing()
			and		countSwap, 0	;=0
			and		countComp, 0
			mov		g_bBreak, false
			mov		g_bReadyStart, true
		.endif
		mov		esi, hdcMainForm	;HDC
		SetTextColor(esi, 0FFFFFFh)
		SetBkColor(esi, 0)
		mov		ecx, g_iNumFunc
		sprintf(&buff, "%d %s:  Array Size: %d, Comp: %d, Swaps: %d",ecx, lstFuncSort[ecx*8].sNameProc, ArraySize, countComp, countSwap)
		.while (eax<77)	;заполняем строку пробелами, для стирания мусора
			mov		buff[eax], ' '
			inc		eax
		.endw
		mov		buff[eax], 0
		TextOut(esi, 0, 0, &buff, eax)
		sprintf(&buff, "Delay: %d   ", g_iDelay)
		TextOut(esi, 0, 15, &buff, eax)
		GetClientRect(hWnd, &rect)
		mov		esi, rect.bottom
		sub		esi, ColumnHeight
		mov		eax, 2
		mov		rect.left, eax
		add		eax, g_iColumnWidth
		mov		rect.right, eax
		.for (edi=0: edi<ArraySize: edi++)
			mov		ebx, ColumnHeight-1
			mov		ecx, Array[edi*4]
			.if (g_bActiveProcces && g_iNumFunc==number_RadixSort)
				xor		ecx, INT_MIN
			.endif
			sub		ebx, ecx
			add		ebx, esi
			mov		rect.top, esi	;=0
			mov		rect.bottom, ebx
			FillRect(hdcMainForm, &rect, COLOR_WINDOWTEXT)
			mov		rect.top, ebx
			lea		eax, [esi+ColumnHeight]
			mov		rect.bottom, eax
			mov		ecx, Array[edi*4]
			.if (g_bActiveProcces && g_iNumFunc==number_RadixSort)
				xor		ecx, INT_MIN
			.endif
			.if (bComparison[edi])
				mov		edx, COLOR_SCROLLBAR
				mov		bComparison[edi], false
			.else
				mov		edx, BrushColumn[ecx*4]
			.endif
			FillRect(hdcMainForm, &rect, edx)
			mov		eax, g_iColumnWidth
			inc		eax
			add		rect.left, eax
			add		rect.right, eax
		.endfor
;	.elseif (ebx == WM_SETFOCUS || ebx == WM_CAPTURECHANGED);перерисовать форму
	.elseif (ebx == WM_CREATE)
		.for (edi=0: edi<ColumnHeight: edi++)
			ColorGradient(edi)
			mov		BrushColumn[edi*4], CreateSolidBrush(eax)
		.endfor
		mov		hdcMainForm, GetDC(hWnd)
		Mixing()
		mov		g_bReadyStart, true
		mov		g_iDelay, 40
		SetTimer(hWnd, TIMER_ID, 25, NULL)
	.elseif (ebx == WM_KEYDOWN)	;отслеживаем клавиатуру
		xor		ebx, ebx
		mov		al, wParam.b0		;key = wParam & 0xFF;
		.if (al==' ')		;Space	start
			.if (!g_bActiveProcces)
				.if (g_bPause==false && !g_bReadyStart)
					Mixing()
				.endif
				mov		g_bReadyStart, bl;=false
				mov		g_bPause, bl;=false
				mov		g_iDelayPause, ebx
				mov		countSwap, ebx	;=0
				mov		countComp, ebx
				mov		ecx, g_iNumFunc
				CreateThread(ebx, ebx, lstFuncSort[ecx*8].pProc, ebx, NORMAL_PRIORITY_CLASS, &ThreadID)
			.else
				xor		g_bPause, 1
				.if (g_bPause)
					mov		g_iDelayPause, 10
				.else
					mov		g_iDelayPause, ebx	;=0
				.endif
			.endif
		.elseif (al==13)	;Enter	clear
			.if (!g_bActiveProcces)
				Mixing()
				mov		countSwap, ebx	;=0
				mov		countComp, ebx
				mov		g_bReadyStart, true
			.else
				mov		g_bBreak, true
			.endif
		.elseif (al==187 || al=='k');'+'
			mov		ecx, g_iDelay
			.if (sdword ptr ecx<=10)
				mov		eax, 1
			.elseif (sdword ptr ecx<=50)
				mov		eax, 5
			.elseif (sdword ptr ecx<=100)
				mov		eax, 10
			.else
				mov		eax, 50
			.endif
			sub		ecx, eax
			.if (sdword ptr ecx<MAX_SLEEP)
				mov		ecx, MAX_SLEEP
			.endif
			mov		g_iDelay, ecx
		.elseif (al==189 || al=='m');'-'
			mov		ecx, g_iDelay
			.if (sdword ptr ecx<10)
				mov		eax, 1
			.elseif (sdword ptr ecx<50)
				mov		eax, 5
			.elseif (sdword ptr ecx<100)
				mov		eax, 10
			.else
				mov		eax, 50
			.endif
			add		ecx, eax
			.if (sdword ptr ecx>MIN_SLEEP)
				mov		ecx, MIN_SLEEP
			.endif
			mov		g_iDelay, ecx
		.elseif (al=='Q')
			.if (!g_bActiveProcces)
				mov		countSwap, ebx	;=0
				mov		countComp, ebx
				dec		g_iNumFunc
				.if (g_iNumFunc<0)
					mov		g_iNumFunc, lstFuncSort_Size-1
				.endif
			.endif
		.elseif (al=='A')
			.if (!g_bActiveProcces)
				mov		countSwap, ebx	;=0
				mov		countComp, ebx
				inc		g_iNumFunc
				.if (g_iNumFunc>lstFuncSort_Size-1)
					and		g_iNumFunc, 0;=0
				.endif
			.endif
		.endif
	.elseif (ebx == WM_DESTROY)
		PostQuitMessage(NULL)
	.else
		DefWindowProc(hWnd, ebx, wParam, lParam)
		;//перемещаем форму за любую часть!
		.if (ebx == WM_NCHITTEST && eax == HTCLIENT)
			mov		eax, HTCAPTION
		.endif
		jmp		EXIT
	.endif
	mov		eax, TRUE
EXIT:
	ret
WndProc endp

main_startup_Win32_END